import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.zip.GZIPInputStream;

public class MakeHistogram {

	ArrayList<CountRepetition> countRepetition_List = new ArrayList<CountRepetition>();

	FindRepetition find = new FindRepetition();


	@SuppressWarnings("unchecked")
	public void make_histogram(String filename, int type, int approx, String output_histogram, int debug, String output_repeatlist, int paired, String filename2, String output_fasta) {
		String line, line2 = "";
		String pre_line ="";
		String pre_line2 ="";		
		int count_line = 0;
		
		try {

			BufferedReader  br;
			FileReader in = null;
			GZIPInputStream gzipInStream = null;

			BufferedReader  br2 = null;
			FileReader in2 = null;
			GZIPInputStream gzipInStream2 = null;
			
			PrintWriter repeat_out = null;
			PrintWriter fasta_out = null;
			
			if (debug == 2) {
				File outputrepeatlist = new File(output_repeatlist);
				repeat_out = new PrintWriter(new BufferedWriter(new FileWriter(outputrepeatlist)));
			}
			
			if(type == 1){
				in = new FileReader(filename);
				br = new BufferedReader(in);
			} else {
				gzipInStream = new GZIPInputStream(new FileInputStream(filename));
				br = new BufferedReader(new InputStreamReader(gzipInStream));
			}
			
			if(paired == 2){
				if(type == 1){
					in2 = new FileReader(filename2);
					br2 = new BufferedReader(in2);
				} else {
					gzipInStream2 = new GZIPInputStream(new FileInputStream(filename2));
					br2 = new BufferedReader(new InputStreamReader(gzipInStream2));
				}
				File outputfasta = new File(output_fasta);
				fasta_out= new PrintWriter(new BufferedWriter(new FileWriter(outputfasta)));
			}
				
			while ((line = br.readLine()) != null) {

				count_line++;

				if (count_line % 4 == 1) {
				    pre_line = line.substring(1);
				}
				
				if (paired == 2){
					if((line2 = br2.readLine()) != null){
						if (count_line % 4 == 1) {
						    pre_line2 = line2.substring(1);
						}
					}else {
						break;
					}
				}

				if (count_line % 4 != 2) {
					continue;
				}

				
				RepetitionList r_list = new RepetitionList();

				find.findMaximalRepetition(line, r_list);
				
				if (approx == 2) {
					find.extendMaximalRepetition(pre_line, line, r_list);
				}
				
				if(debug == 2) {
					repeat_out.println(pre_line);
					r_list.print_repetition(repeat_out, line);
				}
				
				RepetitionList r_list2 = new RepetitionList();
				
				if (paired == 2){
					find.findMaximalRepetition(line2, r_list2);
					if (approx == 2) {
						find.extendMaximalRepetition(pre_line2, line2, r_list2);
					}
					if(debug == 2) {
						repeat_out.println(pre_line2);
						r_list2.print_repetition(repeat_out, line2);
					}
					
					if(r_list.get_max_repetition_length() == line.length()){
					    fasta_out.println(">" + pre_line + "_" + line  + "_" +  get_representative( line.substring(r_list.get_max_repetition_left_index(), r_list.get_max_repetition_left_index() 
															+ r_list.get_max_repetition_unit_size())) + "_pairedend" );
					    fasta_out.println(line2);
					}
					if(r_list2.get_max_repetition_length() == line2.length()){
					    fasta_out.println(">" + pre_line2 + "_" + line2 + "_" + get_representative( line2.substring(r_list2.get_max_repetition_left_index(), r_list2.get_max_repetition_left_index() 
															+ r_list2.get_max_repetition_unit_size())) +  "_pairedend" );
						fasta_out.println(line);
					}
				}

				for (int i_rep = 0; i_rep < r_list.get_Repetition_ListSize(); i_rep++) {
				    
				    if (countRepetition_List.size() == 0) {
					if (!isIncludingN(r_list.get_repetition_string(line, i_rep))) {
					    countRepetition_List.add(new CountRepetition(get_representative(r_list.get_repetition_string(line, i_rep)), line.length(), r_list
											 .get_MaximalRepetition_length(i_rep))); 
					}
				    }

				    else {
					boolean is_equal_repetition = false;

					String temp = get_representative(r_list.get_repetition_string(line, i_rep));

					for (int i_list = 0; i_list < countRepetition_List.size(); i_list++) {

					    if (countRepetition_List.get(i_list).get_repetition_string().compareTo(temp) == 0) {

						countRepetition_List.get(i_list).increment_histgram(r_list.get_MaximalRepetition_length(i_rep));

						is_equal_repetition = true;
						break;
						
					    }
					    
					}

					if (!is_equal_repetition) {
					    if (!isIncludingN(r_list.get_repetition_string(line, i_rep))) {
						countRepetition_List.add(new CountRepetition(get_representative(r_list.get_repetition_string(line, i_rep)), line.length(), r_list
											     .get_MaximalRepetition_length(i_rep))); 
					    }
					}
				    }
				}

				if(paired ==2 ) {
					for (int i_rep = 0; i_rep < r_list2.get_Repetition_ListSize(); i_rep++) {
				    
						if (countRepetition_List.size() == 0) {
							if (!isIncludingN(r_list2.get_repetition_string(line2, i_rep))) {
								countRepetition_List.add(new CountRepetition(get_representative(r_list2.get_repetition_string(line2, i_rep)), line2.length(), r_list2
											 .get_MaximalRepetition_length(i_rep))); 
							}	
						}

						else {
							boolean is_equal_repetition = false;

							String temp = get_representative(r_list2.get_repetition_string(line2, i_rep));

							for (int i_list = 0; i_list < countRepetition_List.size(); i_list++) {

								if (countRepetition_List.get(i_list).get_repetition_string().compareTo(temp) == 0) {

									countRepetition_List.get(i_list).increment_histgram(r_list2.get_MaximalRepetition_length(i_rep)); 

									is_equal_repetition = true;
									break;
						
								}
					    
							}

							if (!is_equal_repetition) {
								if (!isIncludingN(r_list2.get_repetition_string(line2, i_rep))) {
									countRepetition_List.add(new CountRepetition(get_representative(r_list2.get_repetition_string(line2, i_rep)), line2.length(), r_list2
											.get_MaximalRepetition_length(i_rep))); 
								}
							}
						}
					}

				}

			}
			br.close();
			if (debug == 2){
				repeat_out.close();
			}
			if (paired == 2) {
				fasta_out.close();
			}
			if (type == 1){
				in.close();
			}else {
				gzipInStream.close();
			}
		} catch (Exception e) {
			System.out.println(e);
		}


		try {
			File outputfile = new File(output_histogram);
			PrintWriter hist_out = new PrintWriter(new BufferedWriter(new FileWriter(outputfile)));
			
			Collections.sort(countRepetition_List, new Comparator());			
			for (int i = 0; i < countRepetition_List.size(); i++) {
				countRepetition_List.get(i).print_histogram(hist_out);
			}
			hist_out.close();
		} catch (Exception e) {
			System.out.println(e);
		}

	}

	@SuppressWarnings("rawtypes")
	class Comparator implements java.util.Comparator {
		public int compare(Object s, Object t) {

			if (((CountRepetition) s).get_repetition_length() < ((CountRepetition) t).get_repetition_length()) {
				return -1;
			} else if (((CountRepetition) s).get_repetition_length() > ((CountRepetition) t).get_repetition_length()) {
				return 1;
			} else {
				if (((CountRepetition) s).get_repetition_string().compareTo(((CountRepetition) t).get_repetition_string()) > 0) {
					return 1;
				} else if (((CountRepetition) s).get_repetition_string().compareTo(((CountRepetition) t).get_repetition_string()) < 0) {
					return -1;
				} else {
					return 0;
				}
			}
		}
	}

	public String get_representative(String s) {

		StringBuilder str_double = new StringBuilder();

		String temp;

		str_double.append(s);
		str_double.append(s);


		String rep = s;

		for (int i = 0; i < s.length(); i++) {
			temp = str_double.substring(i, i + s.length());
			if (temp.compareTo(rep) < 0) {
				rep = temp;
			}
		}

		str_double = str_double.reverse();

		temp = new String(str_double);

		temp = temp.replace('C', 'Z');
		temp = temp.replace('G', 'C');
		temp = temp.replace('Z', 'G');

		temp = temp.replace('T', 'Z');
		temp = temp.replace('A', 'T');
		temp = temp.replace('Z', 'A');

		str_double = new StringBuilder(temp);
		for (int i = 0; i < s.length(); i++) {
			temp = str_double.substring(i, i + s.length());
			if (temp.compareTo(rep) < 0) {
				rep = temp;
			}
		}


		return rep;
	}

	private boolean isIncludingN(String s) {
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == 'N') {
				return true;
			}
		}
		return false;
	}

	class CountRepetition {
		private String repetition_string;
		private long[] histogram;

	        private int interval = 1;

		public CountRepetition(String period_text, int read_length, int maximal_repetition_length) {

			repetition_string = period_text;

			histogram = new long[(int) Math.ceil((double) read_length / interval)];

			for (int i = 0; i < histogram.length; i++) {
				histogram[i] = 0;
			}

			increment_histgram(maximal_repetition_length);
		}

		public CountRepetition(CountRepetition a) {
			repetition_string = a.get_repetition_string();
			histogram = a.get_histogram();
		}

		public void increment_histgram(int maximal_repetition_length) {
			histogram[(maximal_repetition_length - 1) / interval]++;
		}

		public String get_repetition_string() {
			return repetition_string;
		}

		public int get_repetition_length() {
			return repetition_string.length();
		}

		public long[] get_histogram() {
			return histogram;
		}

		public void print_histogram() {
			System.out.println("repetition_string," + repetition_string);

			for (int i = 0; i < histogram.length; i++) {
			        int j = i + 1;
				System.out.println(j + "," + histogram[i]);
			}
		}

		public void print_histogram(PrintWriter file) {
			file.println("repetition_string," + repetition_string);

			for (int i = 0; i < histogram.length; i++) {
			        int j = i + 1;
				file.println(j + "," + histogram[i]);
			}
		}
		
		
	}

}
